Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxinput.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxinput.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxinput.h
@@ -1,162 +1,128 @@
 /*
- * Copyright 2001,2002 Red Hat Inc., Durham, North Carolina.
+ * Copyright © 2008 Novell, Inc.
  *
- * All Rights Reserved.
- *
- * Permission is hereby granted, free of charge, to any person obtaining
- * a copy of this software and associated documentation files (the
- * "Software"), to deal in the Software without restriction, including
- * without limitation on the rights to use, copy, modify, merge,
- * publish, distribute, sublicense, and/or sell copies of the Software,
- * and to permit persons to whom the Software is furnished to do so,
- * subject to the following conditions:
- *
- * The above copyright notice and this permission notice (including the
- * next paragraph) shall be included in all copies or substantial
- * portions of the Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
- * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
- * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
- * NON-INFRINGEMENT.  IN NO EVENT SHALL RED HAT AND/OR THEIR SUPPLIERS
- * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
- * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
- * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
- * SOFTWARE.
- */
-
-/*
- * Authors:
- *   David H. Dawes <dawes@xfree86.org>
- *   Kevin E. Martin <kem@redhat.com>
- *   Rickard E. (Rik) Faith <faith@redhat.com>
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *
+ * Author: David Reveman <davidr@novell.com>
  */
 
-/** \file
- * This file provides access to:
- * - global variables available to all hw/dmx routines, and
- * - enumerations and typedefs needed by input routines in hw/dmx (and
- *   hw/dmx/input).
- *
- * The goal is that no files in hw/dmx should include header files from
- * hw/dmx/input -- the interface defined here should be the only
- * interface exported to the hw/dmx layer.  \see input/dmxinputinit.c.
- */
- 
 #ifndef DMXINPUT_H
 #define DMXINPUT_H
 
-/** Maximum number of file descriptors for SIGIO handling */
-#define DMX_MAX_SIGIO_FDS 4
+extern DevPrivateKey dmxDevicePrivateKey;
+
+/** Device private area. */
+typedef struct _dmxDevicePriv {
+    DMXInputInfo             *dmxInput;
+    long                     deviceId;
+    long                     masterId;
+    XDevice                  *device;
+    char		     state[32];
+    char		     keysbuttons[32];
+    KeySymsRec               keySyms;
+    KeyCode                  *keycode;
+    xcb_void_cookie_t        grab;
+    int                      grabStatus;
+    Bool                     fakeGrab;
+    Bool                     active;
+
+    Bool (*EventCheck) (DeviceIntPtr, xcb_generic_event_t *);
+    Bool (*ReplyCheck) (DeviceIntPtr, unsigned int, xcb_generic_reply_t *);
+
+    void (*ActivateGrab)   (DeviceIntPtr, GrabPtr, TimeStamp, Bool);
+    void (*DeactivateGrab) (DeviceIntPtr);
+} dmxDevicePrivRec, *dmxDevicePrivPtr;
+
+#define DMX_GET_DEVICE_PRIV(_pDev)				\
+    ((dmxDevicePrivPtr)dixLookupPrivate(&(_pDev)->devPrivates,	\
+					dmxDevicePrivateKey))
+
+void
+dmxInputInit (DMXInputInfo *dmxInput);
+
+void
+dmxInputLogDevices (void);
+
+Bool
+dmxInputEventCheck (DMXInputInfo        *dmxInput,
+		    xcb_generic_event_t *event);
+
+Bool
+dmxFakeMotion (DMXInputInfo *dmxInput,
+	       int          x,
+	       int          y);
+
+void
+dmxEndFakeMotion (DMXInputInfo *dmxInput);
+
+void
+dmxInputGrabKeyboard (DMXInputInfo *dmxInput,
+		      DeviceIntPtr pDevice,
+		      WindowPtr    pWindow);
+
+void
+dmxInputUngrabKeyboard (DMXInputInfo *dmxInput,
+			DeviceIntPtr pDevice,
+			WindowPtr    pWindow);
+
+void
+dmxInputGrabPointer (DMXInputInfo *dmxInput,
+		     DeviceIntPtr pDevice,
+		     WindowPtr    pWindow,
+		     WindowPtr    pConfineTo,
+		     CursorPtr    pCursor);
+
+void
+dmxInputUngrabPointer (DMXInputInfo *dmxInput,
+		       DeviceIntPtr pDevice,
+		       WindowPtr    pWindow);
+
+void
+dmxInputWarpPointer (DMXInputInfo *dmxInput,
+		     DeviceIntPtr pDevice,
+		     int          x,
+		     int          y);
+
+int
+dmxInputEnable (DMXInputInfo *dmxInput);
+
+int
+dmxInputDisable (DMXInputInfo *dmxInput);
+
+int
+dmxInputAttach (DMXInputInfo *dmxInput);
+
+int
+dmxInputDetach (DMXInputInfo *dmxInput);
+
+void
+dmxInputInit (DMXInputInfo *dmxInput);
+
+void
+dmxInputFini (DMXInputInfo *dmxInput);
+
+void
+dmxInitInput (void);
+
+void
+dmxResetInput (void);
 
-struct _DMXInputInfo;
 
-/** Reason why window layout was updated. */
-typedef enum {
-    DMX_UPDATE_REALIZE,         /**< Window realized        */
-    DMX_UPDATE_UNREALIZE,       /**< Window unrealized      */
-    DMX_UPDATE_RESTACK,         /**< Stacking order changed */
-    DMX_UPDATE_COPY,            /**< Window copied          */
-    DMX_UPDATE_RESIZE,          /**< Window resized         */
-    DMX_UPDATE_REPARENT         /**< Window reparented      */
-} DMXUpdateType;
-
-typedef void (*ProcessInputEventsProc)(struct _DMXInputInfo *);
-typedef void (*UpdateWindowInfoProc)(struct _DMXInputInfo *,
-                                     DMXUpdateType, WindowPtr);
-
-/** An opaque structure that is only exposed in the dmx/input layer. */
-typedef struct _DMXLocalInputInfo *DMXLocalInputInfoPtr;
-
-/** State of the SIGIO engine */
-typedef enum {
-    DMX_NOSIGIO = 0,            /**< Device does not use SIGIO at all. */
-    DMX_USESIGIO,               /**< Device can use SIGIO, but is not
-                                 * (e.g., because the VT is switch
-                                 * away). */
-    DMX_ACTIVESIGIO             /**< Device is currently using SIGIO. */
-} dmxSigioState;
-
-/** DMXInputInfo is typedef'd in #dmx.h so that all routines can have
- * access to the global pointers.  However, the elements are only
- * available to input-related routines. */
-struct _DMXInputInfo {
-    const char              *name; /**< Name of input display or device
-                                    * (from command line or config
-                                    * file)  */
-    Bool                    freename; /**< If true, free name on destroy */
-    Bool                    detached; /**< If true, input screen is detached */
-    int                     inputIdx; /**< Index into #dmxInputs global */
-    int                     scrnIdx;  /**< Index into #dmxScreens global */
-    Bool                    core;  /**< If True, initialize these
-                                    * devices as devices that send core
-                                    * events */
-    Bool                    console; /**< True if console and backend
-                                      * input share the same backend
-                                      * display  */
-
-    Bool                    windows; /**< True if window outlines are
-                                      * draw in console */
-
-    ProcessInputEventsProc  processInputEvents;
-    UpdateWindowInfoProc    updateWindowInfo;
-
-                                /* Local input information */
-    dmxSigioState           sigioState;    /**< Current stat */
-    int                     sigioFdCount;  /**< Number of fds in use */
-    int                     sigioFd[DMX_MAX_SIGIO_FDS];    /**< List of fds */
-    Bool                    sigioAdded[DMX_MAX_SIGIO_FDS]; /**< Active fds */
-
-    
-    /** True if a VT switch is pending, but has not yet happened. */
-    int                     vt_switch_pending;
-
-    /** True if a VT switch has happened. */
-    int                     vt_switched;
-
-    /** Number of devices handled in this _DMXInputInfo structure. */
-    int                     numDevs;
-
-    /** List of actual input devices.  Each _DMXInputInfo structure can
-     * refer to more than one device.  For example, the keyboard and the
-     * pointer of a backend display; or all of the XInput extension
-     * devices on a backend display. */
-    DMXLocalInputInfoPtr    *devs;
-
-    char                    *keycodes; /**< XKB keycodes from command line */
-    char                    *symbols;  /**< XKB symbols from command line */
-    char                    *geometry; /**< XKB geometry from command line */
-};
-
-extern int                  dmxNumInputs; /**< Number of #dmxInputs */
-extern DMXInputInfo         *dmxInputs;   /**< List of inputs */
-
-extern void dmxInputInit(DMXInputInfo *dmxInput);
-extern void dmxInputReInit(DMXInputInfo *dmxInput);
-extern void dmxInputLateReInit(DMXInputInfo *dmxInput);
-extern void dmxInputFree(DMXInputInfo *dmxInput);
-extern void dmxInputLogDevices(void);
-extern void dmxUpdateWindowInfo(DMXUpdateType type, WindowPtr pWindow);
-
-/* These functions are defined in input/dmxeq.c */
-extern Bool dmxeqInitialized(void);
-extern void dmxeqEnqueue(DeviceIntPtr pDev, xEvent *e);
-extern void dmxeqSwitchScreen(DeviceIntPtr pDev, ScreenPtr pScreen, Bool fromDIX);
-
-/* This type is used in input/dmxevents.c.  Also, these functions are
- * defined in input/dmxevents.c */
-typedef enum {
-    DMX_NO_BLOCK = 0,
-    DMX_BLOCK    = 1
-} DMXBlockType;
-
-extern void          dmxGetGlobalPosition(int *x, int *y);
-extern DMXScreenInfo *dmxFindFirstScreen(int x, int y);
-extern void          dmxCoreMotion(DevicePtr pDev, int x, int y, int delta,
-                                   DMXBlockType block);
-
-/* Support for dynamic addition of inputs.  This functions is defined in
- * config/dmxconfig.c */
-extern DMXInputInfo *dmxConfigAddInput(const char *name, int core);
 #endif /* DMXINPUT_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlaunch.c
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlaunch.c
@@ -0,0 +1,432 @@
+/*
+ * Copyright © 2005 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authors: David Reveman <davidr@novell.com>
+ *          Matthias Hopf <mhopf@suse.de>
+ */
+
+#include "dmx.h"
+#include "dmxlaunch.h"
+#include "dmxinit.h"
+#include "opaque.h"
+
+#include <X11/Xauth.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <errno.h>
+#include <ctype.h>
+#include <signal.h>
+#include <setjmp.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <sys/stat.h>
+#include <libgen.h>
+#include <fcntl.h>
+
+typedef void (*sighandler_t) (int);
+
+#define XBE_DIE_TIMEOUT 3
+#define XBE_DEV_RANDOM  "/dev/urandom"
+
+static char xbeAuthBuf[256];
+static char *xbeAuthTempl = "/tmp/.Xdmx-auth-XXXXXX";
+static char *xbeAuth      = NULL;
+
+static char *xbeProgs[] = { "/var/X11R6/bin/Xbackend", "/usr/bin/X" };
+static char *xbeProg    = NULL;
+
+static char xbeDisplayBuf[256];
+static char *xbeDisplay      = NULL;
+static int  xbeDisplayOffset = 53;
+
+static pid_t   xbePid = 0;
+static int     receivedUsr1 = 0;
+static jmp_buf jumpbuf;
+
+static char **xbeArgv = 0;
+static int  nXbeArgv  = 0;
+
+static int
+dmxAddXbeArguments (char **argv,
+		    int  n)
+{
+    char **newArgv;
+    int  i;
+
+    newArgv = xrealloc (xbeArgv, sizeof (char *) * (nXbeArgv + n));
+    if (!newArgv)
+	return 0;
+
+    for (i = 0; i < n; i++)
+	newArgv[nXbeArgv + i] = argv[i];
+
+    xbeArgv   = newArgv;
+    nXbeArgv += n;
+
+    return n;
+}
+
+static void
+sigAlarm (int sig)
+{
+    ErrorF ("%s won't die, killing it\n", basename (xbeProg));
+
+    kill (xbePid, SIGKILL);
+    if (xbePid)
+	while (waitpid (xbePid, NULL, 0) == -1 && errno == EINTR);
+}
+
+void
+dmxAbortDisplay (void)
+{
+    sighandler_t oldSigAlarm;
+    unsigned int oldAlarm;
+    int          status = 0;
+    char	 *name;
+
+    if (!xbePid)
+	return;
+
+    name = basename (xbeProg);
+
+    oldAlarm    = alarm (0);
+    oldSigAlarm = signal (SIGALRM, sigAlarm);
+
+    kill (xbePid, SIGTERM);
+
+    alarm (XBE_DIE_TIMEOUT);
+    while (waitpid (xbePid, &status, 0) == -1 && errno == EINTR);
+    alarm (0);
+
+    signal (SIGALRM, oldSigAlarm);
+    alarm (oldAlarm);
+
+    if (WIFEXITED (status))
+    {
+	if (WEXITSTATUS (status))
+	    ErrorF ("%s died, exit status %d\n", name, WEXITSTATUS (status));
+    }
+    else if (WIFSIGNALED (status))
+	ErrorF ("%s died, signal %d\n", name, WTERMSIG (status));
+    else
+	ErrorF ("%s died, dubious exit\n", name);
+
+    if (xbeAuth)
+	unlink (xbeAuth);
+
+    xbePid = 0;
+}
+
+static void
+sigUsr1Waiting (int sig)
+{
+    signal (sig, sigUsr1Waiting);
+    receivedUsr1++;
+}
+
+static void
+sigUsr1Jump (int sig)
+{
+
+#ifdef SIG_BLOCK
+    sigset_t set;
+#endif
+
+    signal (sig, sigUsr1Waiting);
+
+#ifdef SIG_BLOCK
+    sigemptyset (&set);
+    sigaddset (&set, SIGUSR1);
+    sigprocmask (SIG_UNBLOCK, &set, NULL);
+#endif
+
+    longjmp (jumpbuf, 1);
+}
+
+#define AUTH_DATA_LEN 16 /* bytes of authorization data */
+
+static Bool
+dmxSetupAuth (char *name, int authFd)
+{
+    Xauth   auth;
+    int	    randomFd, i;
+    ssize_t bytes, size;
+    char    authHost[256];
+    char    authData[AUTH_DATA_LEN];
+    char    realProg[PATH_MAX], buf[PATH_MAX];
+    FILE    *file;
+    int     virtualFb = FALSE;
+
+    auth.family = FamilyLocal;
+
+    gethostname (authHost, sizeof (authHost));
+
+    auth.address	= authHost;
+    auth.address_length = strlen (authHost);
+
+    auth.number	= strrchr (xbeDisplay, ':');
+    if (!auth.number)
+    {
+	ErrorF ("Bad back-end X display name: %s\n", xbeDisplay);
+	return FALSE;
+    }
+
+    auth.number++;
+
+    auth.number_length = strlen (auth.number);
+    if (!auth.number_length)
+    {
+	ErrorF ("Bad back-end X display name: %s\n", xbeDisplay);
+	return FALSE;
+    }
+
+    auth.name	     = "MIT-MAGIC-COOKIE-1";
+    auth.name_length = strlen (auth.name);
+
+    randomFd = open (XBE_DEV_RANDOM, O_RDONLY);
+    if (randomFd == -1)
+    {
+	ErrorF ("Failed to open " XBE_DEV_RANDOM "\n");
+	return FALSE;
+    }
+
+    bytes = 0;
+    do {
+	size = read (randomFd, authData + bytes, AUTH_DATA_LEN - bytes);
+	if (size <= 0)
+	    break;
+
+	bytes += size;
+    } while (bytes != AUTH_DATA_LEN);
+
+    close (randomFd);
+
+    if (bytes != AUTH_DATA_LEN)
+    {
+	ErrorF ("Failed to read %d random bytes from " XBE_DEV_RANDOM "\n",
+		AUTH_DATA_LEN);
+	return FALSE;
+    }
+
+    auth.data	     = authData;
+    auth.data_length = AUTH_DATA_LEN;
+
+    file = fdopen (authFd, "w");
+    if (!file)
+    {
+	ErrorF ("Failed to open authorization file: %s\n", name);
+	close (authFd);
+	return FALSE;
+    }
+
+    XauWriteAuth (file, &auth);
+    fclose (file);
+
+    strcpy (realProg, xbeProg);
+
+#define MAX_SYMLINKS 32
+
+    for (i = 0; i < MAX_SYMLINKS; i++)
+    {
+	size = readlink (realProg, buf, sizeof (buf) - 1);
+	if (size == -1)
+	    break;
+	
+	memcpy (realProg, buf, size);
+	realProg[size] = '\0';
+    }
+
+    /* a bit hackish but very useful */
+    if (strcmp (basename (realProg), "Xvfb")  == 0 ||
+	strcmp (basename (realProg), "Xfake") == 0)
+	virtualFb = TRUE;
+    
+    dmxAddScreen (basename (realProg),
+		  xbeDisplay,
+		  auth.name,
+		  auth.name_length,
+		  auth.data,
+		  auth.data_length,
+		  virtualFb);
+
+    return TRUE;
+}
+
+Bool
+dmxLaunchDisplay (int argc, char *argv[], int index, char *vt)
+{
+    sighandler_t oldSigUsr1;
+    pid_t	 pid;
+    char	 *name;
+    char	 *auth[] = { "-auth", xbeAuthBuf };
+    char	 *defs[] = { "-terminate", "-nolisten", "tcp" };
+    char	 *endArg = NULL;
+    int		 authFd;
+    int		 mask;
+
+    if (xbePid)
+	return FALSE;
+
+    if (xbeArgv)
+    {
+	free (xbeArgv);
+	xbeArgv = NULL;
+	nXbeArgv = 0;
+    }
+
+    receivedUsr1 = 0;
+
+    strcpy (xbeAuthBuf, xbeAuthTempl);
+    mask = umask (0077);
+    authFd = mkstemp (xbeAuthBuf);
+    umask (mask);
+    if (authFd == -1)
+	FatalError ("Failed to generate unique authorization file\n");
+
+    xbeAuth = xbeAuthBuf;
+
+    if (index && index < argc)
+    {
+        xbeProg = argv[index];
+    }
+    else
+    {
+        struct stat buf;
+	int         i;
+
+	for (i = 0; i < sizeof (xbeProgs) / sizeof (char *); i++)
+	{
+	    if (stat (xbeProgs[i], &buf) == 0)
+	    {
+		xbeProg = xbeProgs[i];
+		break;
+	    }
+	}
+
+	if (!xbeProg)
+            FatalError ("Can't find X server executable\n");
+    }
+
+    if (!dmxAddXbeArguments (&xbeProg, 1))
+	return FALSE;
+
+    if (!dmxAddXbeArguments (auth, sizeof (auth) / sizeof (char *)))
+	return FALSE;
+
+    xbeDisplay = xbeDisplayBuf;
+    sprintf (xbeDisplay, ":%d", xbeDisplayOffset + atoi (display));
+    
+    if (index)
+    {
+	int i;
+
+	for (i = index + 1; i < argc; i++)
+	{
+	    if (*argv[i] == ':')
+	    {
+		xbeDisplay = argv[i];
+		break;
+	    }
+	}
+
+	if (i >= argc)
+	    if (!dmxAddXbeArguments (&xbeDisplay, 1))
+		return FALSE;
+
+        if (argc > index)
+            if (!dmxAddXbeArguments (&argv[index + 1], argc - index))
+                return FALSE;
+    }
+    else
+    {
+	if (!dmxAddXbeArguments (&xbeDisplay, 1))
+	    return FALSE;
+
+        if (!dmxAddXbeArguments (defs, sizeof (defs) / sizeof (char *)))
+            return FALSE;
+    }
+
+    if (vt)
+	if (!dmxAddXbeArguments (&vt, 1))
+	    return FALSE;
+
+    if (!dmxAddXbeArguments (&endArg, 1))
+	return FALSE;
+
+    name = basename (xbeProg);
+
+    if (!dmxSetupAuth (xbeAuth, authFd))
+	FatalError ("Failed to set up authorization: %s\n", xbeAuth);
+
+    oldSigUsr1 = signal (SIGUSR1, sigUsr1Waiting);
+
+    pid = fork ();
+
+    switch (pid) {
+    case -1:
+	perror ("fork");
+	FatalError ("fork");
+	break;
+    case 0:
+	signal (SIGUSR1, SIG_IGN);
+	execv (xbeArgv[0], xbeArgv);
+	perror (xbeArgv[0]);
+	exit (2);
+	break;
+    default:
+	xbePid = pid;
+	break;
+    }
+
+    for (;;)
+    {
+	int status;
+
+	signal (SIGUSR1, sigUsr1Waiting);
+	if (setjmp (jumpbuf))
+	    break;
+
+	signal (SIGUSR1, sigUsr1Jump);
+	if (receivedUsr1)
+	    break;
+
+	if (waitpid (xbePid, &status, 0) != -1)
+	{
+	    if (WIFEXITED (status))
+	    {
+                FatalError ("%s died, exit status %d\n", name,
+                            WEXITSTATUS (status));
+	    }
+	    else if (WIFSIGNALED (status))
+		FatalError ("%s died, signal %d\n", name, WTERMSIG (status));
+	    else
+		FatalError ("%s died, dubious exit\n", name);
+	}
+    }
+
+    signal (SIGUSR1, oldSigUsr1);
+
+    return TRUE;
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlaunch.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlaunch.h
@@ -0,0 +1,32 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authors: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXLAUNCH_H
+#define DMXLAUNCH_H
+
+extern Bool dmxLaunchDisplay (int argc, char *argv[], int index, char *vt);
+extern void dmxAbortDisplay (void);
+
+#endif /* DMXLAUNCH_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlog.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxlog.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxlog.c
@@ -124,21 +124,12 @@ static void dmxHeader(dmxLogLevel logLev
     case dmxFatal:   type = "Fatal Error"; break;
     }
 
-    if (dmxInput && dmxScreen) {
-        ErrorF("(%s) dmx[i%d/%s;o%d/%s]: ", type,
-               dmxInput->inputIdx, dmxInput->name,
-               dmxScreen->index, dmxScreen->name);
-    } else if (dmxScreen) {
-        ErrorF("(%s) dmx[o%d/%s]: ", type,
-               dmxScreen->index, dmxScreen->name);
-    } else if (dmxInput) {
-        const char *pt = strchr(dmxInput->name, ',');
-        int        len = (pt
-                          ? (size_t)(pt-dmxInput->name)
-                          : strlen(dmxInput->name));
+    if (dmxInput)
+	dmxScreen = (DMXScreenInfo *) dmxInput;
 
-        ErrorF("(%s) dmx[i%d/%*.*s]: ", type,
-               dmxInput->inputIdx, len, len, dmxInput->name);
+    if (dmxScreen) {
+        ErrorF("(%s) dmx[o%d/%s/%s]: ", type,
+               dmxScreen->index, dmxScreen->display, dmxScreen->name);
     } else {
         ErrorF("(%s) dmx: ", type);
     }
